<?php


class RSPW_Postcode_Rule implements RSPW_Rule {


	/**
	 * @param array $rule
	 * @param array $package
	 *
	 * @return boolean
	 */
	public function validate( $rule, $package ) {
		$postcode = $package['destination']['postcode'];
		$operator = RSPW_Operators_Factory::make( $rule['operator'] );
		return $operator->match( $rule['value_postcode'], $postcode );
	}

	/**
	 * @return array
	 */
	public function get_operators_labels() {
		return array(
			RSPW_Operators_Factory::OPERATOR_IS     => __( 'is', 'restricted-shipping-and-payment-for-woocommerce' ),
			RSPW_Operators_Factory::OPERATOR_IS_NOT => __( 'is not', 'restricted-shipping-and-payment-for-woocommerce' ),
		);
	}

	/**
	 * @return array
	 */
	public function get_meta_box_fields() {
		return array(
			array(
				'name'    => __( 'Postcode', 'restricted-shipping-and-payment-for-woocommerce' ),
				'id'      => 'value_postcode',
				'type'    => 'text_medium',
				'classes' => 'value_field postcode',
			),
		);
	}
}
